Attribute VB_Name = "modDirectSound"
Option Explicit

Public Type WAVEFORMATEX
        wFormatTag As Integer
        nChannels As Integer
        nSamplesPerSec As Long
        nAvgBytesPerSec As Long
        nBlockAlign As Integer
        wBitsPerSample As Integer
End Type

Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByVal Destination As Long, ByVal Source As Long, ByVal Length As Long)

Public DS As IDirectSound
'You can use as many channels as you want but keep in mind
'that they take up system resources.
Public Const MAX_CHANNELS = 5
Public DSB(MAX_CHANNELS) As IDirectSoundBuffer

'Call this sub to play a wav file from a specific channel,after you've
'initialized DirectSound.

Sub Play_Sound(sWaveFile As String, SLoop As Boolean, SPlayStop As Boolean, SChannel As Integer)
On Error GoTo ErrorPlaySound

Dim lngFlag As Long
Dim sFilename As String

If SLoop Then lngFlag = DSBPLAY_LOOPING

sFilename = sWaveFile


If SPlayStop Then
    If Not (DSB(SChannel) Is Nothing) Then
        DSB(SChannel).Stop
           Set DSB(SChannel) = Nothing
    End If
    LoadWAVIntoDSB DS, sFilename, DSB(SChannel)
    DSB(SChannel).Play 0, 0, lngFlag
Else
    If Not (DSB(SChannel) Is Nothing) Then
        DSB(SChannel).Stop
        Set DSB(SChannel) = Nothing
    End If
End If
Exit Sub

ErrorPlaySound:
MsgBox Err.Description, , "Play_Sound ERROR"
End Sub


' Loads a Wave file into a direct sound buffer.You never
'have to call this sub,because it's called by Play_Sound.

Sub LoadWAVIntoDSB(Lds As IDirectSound, ByVal fName As String, Ldsb As IDirectSoundBuffer)
    
On Error GoTo ErrorLoadWAV
Dim hWave As Long
Dim pcmwave As WAVEFORMATEX
Dim lngSize As Long
Dim lngPosition As Long
Dim ptr1 As Long, ptr2 As Long, lng1 As Long, lng2 As Long
Dim aByte() As Byte

ReDim aByte(1 To FileLen(fName))
hWave = FreeFile
Open fName For Binary As hWave
Get hWave, , aByte
Close hWave
lngPosition = 1
While Chr$(aByte(lngPosition)) + Chr$(aByte(lngPosition + 1)) + Chr$(aByte(lngPosition + 2)) <> "fmt"
    lngPosition = lngPosition + 1
Wend
CopyMemory VarPtr(pcmwave), VarPtr(aByte(lngPosition + 8)), Len(pcmwave)
While Chr$(aByte(lngPosition)) + Chr$(aByte(lngPosition + 1)) + Chr$(aByte(lngPosition + 2)) + Chr$(aByte(lngPosition + 3)) <> "data"
    lngPosition = lngPosition + 1
Wend
CopyMemory VarPtr(lngSize), VarPtr(aByte(lngPosition + 4)), Len(lngSize)
Dim dsbd As DSBUFFERDESC
With dsbd
    .dwSize = Len(dsbd)
    .dwFlags = DSBCAPS_CTRLDEFAULT
    .dwBufferBytes = lngSize
    .lpwfxFormat = VarPtr(pcmwave)
End With
Lds.CreateSoundBuffer dsbd, Ldsb, Nothing
Ldsb.Lock 0&, lngSize, ptr1, lng1, ptr2, lng2, 0&
CopyMemory ptr1, VarPtr(aByte(lngPosition + 4 + 4)), lng1
If lng2 <> 0 Then
    CopyMemory ptr2, VarPtr(aByte(lngPosition + 4 + 4 + lng1)), lng2
End If
Exit Sub

ErrorLoadWAV:

MsgBox Err.Description, , "LoadWAVIntoDSB ERROR"

End Sub



'You have to call this before playing any wav files
Public Sub InitializeDirectSound(fForm As Form)

'Setup sound engine. You have to pass a form in your application
'(the main one usually) in the SetCooperativeLevel sub of the
'IDirectSound object.

DirectSoundCreate ByVal 0&, DS, Nothing
Call DS.SetCooperativeLevel(fForm.hWnd, DSSCL_NORMAL)

End Sub

'You have to call this sub before ending your application
Public Sub TerminateDirectSound()
    
Dim I As Integer
For I = 0 To MAX_CHANNELS
    Set DSB(I) = Nothing
Next I
Set DS = Nothing

End Sub

'Call this function to see if a certain channel is
'currently playing  a sound
Public Function ChannelPlaying(ByVal Channel As Integer) As Boolean

    Dim CurrentPos As Long, WritePos As Long
    On Error Resume Next
    
    DSB(Channel).GetCurrentPosition CurrentPos, WritePos
    
    ChannelPlaying = (CurrentPos <> 0)

End Function
